import java.util.concurrent.CountDownLatch;
 abstract class Production extends Thread {
 Production(Vertex Vert,CountDownLatch Barrier){
 m_vertex = Vert;
 m_barrier = Barrier;
 }
 //returns first vertex from the left
 abstract Vertex apply(Vertex v);
 //run the thread
 public void run() {
 //apply the production
 m_vertex = apply(m_vertex);
try {
 m_barrier.countDown();
 } catch (InterruptedException e) {
 e.printStackTrace(); 
 	}
 }
 //vertex where the production will be applied
 Vertex m_vertex;
 //productions counter
 CountDownLatch m_barrier;
 }